#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire1200five4xi.py">
#<abstract4xi abstract = "fires to direction five and to distance 1200"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2five4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2FIVE - COORDINATE SIGNS OF SHOOT2FIVE4XI: (X - ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2five12004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2five12004xi = {
                1: '-1006x105y644z',
                2: '-1017x53y634z',
                3: '-1024x0y624z',
                4: '-1026x574y237z',
                5: '-1050x42y764z',
                6: '-1057x520y225z',
                7: '-1085x465y214z',
                8: '-1109x408y202z',
                9: '-1131x350y190z',
                10: '-1150x291y178z',
                11: '-1165x231y166z',
                12: '-1177x170y154z',
                13: '-1186x108y142z',
                14: '-1191x46y130z',
                15: '-122x382y1130z',
                16: '-127x746y931z',
                17: '-128x811y875z',
                18: '-131x1106y444z',
                19: '-146x386y1126z',
                20: '-14x4y1199z',
                21: '-168x747y923z',
                22: '-171x388y1122z',
                23: '-172x811y866z',
                24: '-190x1102y433z',
                25: '-196x388y1118z',
                26: '-209x746y915z',
                27: '-217x809y858z',
                28: '-222x387y1113z',
                29: '-248x1095y421z',
                30: '-248x384y1109z',
                31: '-251x743y908z',
                32: '-261x805y850z',
                33: '-26x7y1199z',
                34: '-274x380y1104z',
                35: '-293x737y900z',
                36: '-2x1y1199z',
                37: '-300x373y1099z',
                38: '-306x1085y410z',
                39: '-306x798y841z',
                40: '-327x365y1094z',
                41: '-335x729y892z',
                42: '-351x789y832z',
                43: '-353x355y1090z',
                44: '-364x1071y399z',
                45: '-36x354y1145z',
                46: '-377x718y884z',
                47: '-379x344y1084z',
                48: '-38x8y1199z',
                49: '-395x777y824z',
                50: '-405x330y1079z',
                51: '-418x705y875z',
                52: '-421x1054y388z',
                53: '-431x315y1074z',
                54: '-440x762y815z',
                55: '-456x298y1069z',
                56: '-460x689y867z',
                57: '-477x1034y376z',
                58: '-480x279y1063z',
                59: '-483x745y806z',
                60: '-500x671y859z',
                61: '-503x258y1057z',
                62: '-50x8y1198z',
                63: '-526x236y1052z',
                64: '-526x725y797z',
                65: '-532x1011y365z',
                66: '-540x650y850z',
                67: '-547x212y1046z',
                68: '-567x186y1040z',
                69: '-569x702y788z',
                70: '-56x363y1142z',
                71: '-579x627y842z',
                72: '-586x159y1034z',
                73: '-586x985y353z',
                74: '-604x130y1028z',
                75: '-610x677y779z',
                76: '-617x602y833z',
                77: '-620x100y1022z',
                78: '-62x6y1198z',
                79: '-635x68y1015z',
                80: '-639x956y342z',
                81: '-648x36y1009z',
                82: '-650x650y770z',
                83: '-654x574y825z',
                84: '-659x2y1002z',
                85: '-689x620y761z',
                86: '-690x544y816z',
                87: '-690x923y330z',
                88: '-724x512y807z',
                89: '-726x588y751z',
                90: '-740x889y319z',
                91: '-74x4y1197z',
                92: '-757x478y798z',
                93: '-762x554y742z',
                94: '-77x371y1138z',
                95: '-787x851y307z',
                96: '-788x442y789z',
                97: '-796x517y733z',
                98: '-817x403y780z',
                99: '-829x478y723z',
                100: '-833x811y296z',
                101: '-844x363y771z',
                102: '-84x807y883z',
                103: '-859x437y713z',
                104: '-869x321y762z',
                105: '-86x0y1196z',
                106: '-876x768y284z',
                107: '-887x395y704z',
                108: '-892x277y752z',
                109: '-912x232y743z',
                110: '-913x350y694z',
                111: '-918x723y272z',
                112: '-930x185y734z',
                113: '-937x304y684z',
                114: '-946x137y724z',
                115: '-956x675y261z',
                116: '-958x256y674z',
                117: '-959x88y714z',
                118: '-977x207y664z',
                119: '-993x157y654z',
                120: '-993x625y249z',
                121: '-99x377y1134z'}

#"
#"/>

# ----------------------------------------------------------------------------------------------------------------
#<function4xi function = "fire1200five4xi" usage = "target function for charge12004xi4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# ----------------------------------------------------------------------------------------------------------------
def fire1200five4xi(queue2five, consumer_channel2five, publisher_channel2five):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE1200FIVE4XIFIVE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE1200FIVE4XIFIVE4XI -  QUEUE2FIVE: ", queue2five)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE1200FIVE4XIFIVE4XI -  CONSUMER_CHANNEL2FIVE: ", consumer_channel2five)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE1200FIVE4XIFIVE4XI -  PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE1200FIVE4XIFIVE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2five.put(shot2five12004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE1200FIVE4XIFIVE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE1200FIVE4XIFIVE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE1200FIVE4XIFIVE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2five8shot2five12004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2five8shot2five12004xi</nack2put4xi>" 
            
        publisher_channel2five.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE1200FIVE4XIFIVE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE1200FIVE4XIFIVE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE1200FIVE4XIFIVE4XI - RETURNING QUEUE OBJECT QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi())  
        # 
            
    return queue2five    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire1200five4xi.py                             
# -------------------------------------------------------------------------------------------------                